### JWT
Color Recipes Explorer utilise JWT (JSON Web Tokens) pour garder une trace des utilisateurs authentifiés.

#### Clé secrète
- Type: Manuelle
- Propriété: `cre.security.jwt-secret`
- Variable d'environnement: `CRE_SECURITY_JWT_SECRET`

Les tokens JWT sont signés numériquement avec une clé secrète. Cela permet de sécuriser l'information qu'ils contiennent et ainsi s'assurer qu'ils peuvent seulement être lus par ceux qui ont accès à la clé secrète. Une clé secrète est pré-configurée dans chaque installation pour qu'elles fonctionnent sans configuration. Par contre, il est fortement recommandé de la changer car cette valeur est accessible publiquement.

#### Expiration
- Type: Manuelle
- Propriété: `cre.security.jwt-duration`
- Variable d'environnement: `CRE_SECURITY_JWT_DURATION`
- Format: Millisecondes
- Valeur par défaut: `18000000` (5 heure)

Les tokens JWT ont une expiration pour empêcher qu'un token volé soit éternellement valide.

### Configurations
#### Sel
- Type: Manuelle
- Propriété: `cre.security.config-salt`
- Variable d'environnement: `CRE_SECURITY_CONFIG_SALT`
- Format: Chaîne de caractères encodée en hexadécimal

Le sel est utiliser pour encrypter les configurations qui contiennent des informations sensibles, tel que le mot de passe de la base de donnée. Un sel unique est généré automatiquement lorsqu'il n'y en a aucun de configuré. Par contre, il est fortement recommandé de définir un sel car la valeur générée est stockée dans le même fichier que les configurations sensibles, ce qui n'est pas sécuritaire. Il est aussi important de garder le sel car s'il est perdu, les configurations sensibles ne seront plus lisibles.

### Utilisateur root
L'utilisateur root est toujours présent. Il a tous les droits et doit donc être plus sécurisé. Il devrait seulement être utilisé lorsque c'est nécessaire, lors du premier démarrage lorsqu'il n'y a aucun autre utilisateur, ou lorsque l'installation est en mode 'urgence' par exemple.

#### Identifiant
- Type: Manuelle
- Propriété: `cre.security.root.id`
- Variable d'environnement: `CRE_SECURITY_ROOT_ID`
- Valeur par défaut: `9999`

#### Mot de passe
- Type: Manuelle
- Propriété: `cre.security.root.password`
- Variable d'environnement: `CRE_SECURITY_ROOT_PASSWORD`
- Valeur par défaut: `password`
